## 开发环境配置
    $ git clone git@gitlab.alibaba-inc.com:abc/abc-ui.git
    $ cd abc-ui

    $ git checkout -b server origin/server

    $ npm install （ubuntu 下是 sudo npm install）
    $ cd server/public
    $ bower install
    $ cd ..
    $ node app

    $ git clone git@gitlab.alibaba-inc.com:abc/generator-kissy-cake.git
    $ sudo npm link
    $ cd path/to/test
    $ npm link generator-kissy-cake

## 安装环境配置
    $ sudo chmod a+x path_abc/lib/abc-cli.js
    $ sudo ln -s path_abc/lib/abc-cli.js /usr/bin/abc

打开浏览器 http://127.0.0.1:3000

## 调用接口示例

    //连接到服务器
    io.connect();

    io.emit('list', function(data){
      //data.list 为当前所有连接的列表
    });

    io.emit('history', function(data){
      //data.list
    });

    //进入应用目录
    io.emit('cd', {
        root: '/home/qipbbn/lib/myapp'
    }, function(data){
      if (data.status === 'ok') {
        run();
      } else {
        alert(data.message);
      }
    });

    io.on('action:status:update', function (data) {
        if(data.status === 'ready') {
            run();
        }
    });

    function run() {
      io.emit('action:yeoman:run', {
          type: 'kissy-cake'
      });

      io.on('action:yeoman:start', function(){
        alert('yeoman start to run');
      });

      io.on('action:yeoman:end', function(){
        alert('yeoman start to run');
      });
    }


具体接口看下面 通信约定


## 通信约定

通信采用 [socket.io](http://socket.io)

### Client 可以 emit 以下事件：

#### `cd`

连接到一个目录， 只有在 action:ready 事件侦听到后，才可以对应用目录执行具体操作

参数

- **root**, {String}, Root of your assets

返回

- **status**, {String} ok|error


#### `exit`

退出当前目录

参数

无

返回

- **status**, {string} ok|error

#### `history`

查询近期使用过的应用列表，用于展现在首页上

参数

无

返回

- **status** {String} ok|error
- list {Array} 历史列表

#### `info`

查询当前应用信息, 必须先连接到一个目录。 当目录还没有 ready的时候， 返回为 null

参数

无

return ｛Object｝

- abc {Object} abc.json
- type {String} type of project
- path {String} root path of project
- name {String} name of project
- author {Object} infomation of author
- author.name {String} name of author
- author.email {String} email of author


#### `action:yeoman:run`

参数

- **type** {String} 目录规范名称， 如 'kissy-pie'
- **sub** {String} 目录规范名称， 如 'page'
- **args** {Array} 参数列表，与命令行参数对应

返回

无


#### `action:yeoman:resolve`

处理交互

参数

- **type** {String} resolve type conflict|prompt
- **filepath** {String} path of file to resolve
- **method** {String} 选择的解决冲突的方法 overwrite|quit|skip
- **props** {Object} prompt key value map, only valid when type is prompt


返回

无



#### `action:yeoman:exit`

退出yeoman 打包

参数

-**arguments** {Array} 参数列表，与命令行地参数对应

返回

返回

- **status** {String} ok|error
- **data** {Object} 对应命令的返回







### 监听 Server 端发回的消息：

可以端可以通过侦听服务器的时间，来实时做出UI上面的响应

#### `cd`

目录结构切换

参数

- current {String} 当前目录
- prev {String} 切换前目录

#### `action:resolvable`

处理人机交互

参数

- type, {String}, 交互事件类型
- data

type 有下面几种

- prompt
- conflict

##### prompt

参数

- prompts, {Array}, 参数列表
- prompts[].key, {String}, 键名
- prompts[].title, {String}, 标题
- prompts[].title, {String}, 描述
- prompts[].default, {String}, 默认值

示例：


    {
        type: 'prompt',
        prompts: [
            {
                key: 'appName',
                title: 'App Name',
                desc: 'Name of your App',
                default: 'foo'
            }
        ]
    }



完成这个交互，需要向服务器 emit resolve 事件， 示例：

````js
io.emit('resolve', {
  props: {
      appName: 'myApp',
      cssEngine: 'less'
  };
});
````

#### `action:ready`

连接的目录检查并初始化完成时触发。

参数

无

#### `action:status:update`

状态改变时触发

参数

- status {String} 参数列表见下面

参数列表

- starting:  启动中
- checking: 开始检查
- checking-npm: 开始检查 NPM 模块
- install-npm: 开始安装 NPM 模块
- ready: 启动完成



#### `action:yeoman:start`

yeoman 开始运行


#### `action:yeoman:log`

yeoman 的运行日志， yeoman 开始运行后侦听

参数

- messages {Array} 参数列表


#### `action:yeoman:error`

yeoman 的报错信息， yeoman 开始运行后侦听

参数

- message {String} 当前目录

#### `action:yeoman:exit`

yeoman退出， yeoman 开始运行后侦听


#### `action:grunt:run`

grunt 开始运行

参数

- tasks {Array} 要运行的任务
- options {Object} 任务参数

#### `action:grunt:log`

grunt 的运行日志， grunt运行时侦听

参数

- messages {Array} 参数列表


#### `action:grunt:error`

grunt 的报错消息， grunt运行时侦听

参数

- message {Array} 参数列表

#### `action:grunt:exit`

grunt 退出， grunt运行时侦听

