var global = require('./global');
var installer = require('./installer');
var path = require('path');
var fs = require('fs');

//检查 NPM 是否安装
exports.npm = function npm(root, callback) {
    // check install cache
    var npmCache = global.get('npmCache');

    if (!npmCache) {
        npmCache = [];
    }

    if (npmCache.indexOf(root) > -1) {
        callback(null, {
            installed: true,
            status: 'cached'
        });
        return;
    }

    var pakJSON = path.join(root, 'package.json');

    if (!fs.existsSync(pakJSON)) {
        callback(null, {
            installed: false,
            status: 'no package'
        });
        return;
    }

    return installer.run('install', '', null, {
        cwd: root
    }, function(err){

        if (err) {
            callback(err);
            return;
        }
        callback(null, {
            installed: true,
            status: 'install'
        });

        // then cache it
        npmCache.push(root);
        global.set('npmCache', npmCache);
    });
};

exports.clearCache = function (root) {
    var npmCache = global.get('npmCache');

    if (!npmCache) {
        return;
    }

    npmCache = npmCache.filter(function(cache){
        return cache !== root;
    });

    global.set('npmCache', npmCache);
};