module.exports = {

    children: [],

    kill: function(id) {

        this.children.forEach(function(child){
            if (child.pid === id) {
                child.send({
                    type: 'kill'
                });
            }
        });

    },

    add: function(child) {

        if (!child) {
            return null;
        }

        this.children.push(child);
        child.on('exit', function () {
            this.children = this.children.filter(function(c) {
                return c.pid !== child.pid;
            });
        }.bind(this));

        return child.pid;
    },

    list: function () {
        return this.children;
    }

};