var gm = require('./generator-manager');
var _ = require('lodash');

module.exports = {
    getAll: function (callback) {

        var types = [
            {
                name: 'kissy-cake',
                title: 'Kissy Cake',
                desc: 'Kissy Cake is delicious!',
                homepage: 'http://abc.f2e.taobao.net/specs/kissy-cake.html',
                issues: 'http://gitlab.taobao.ali.com/abc/generator-kissy-cake/issues'
            },

            {
                name: 'kissy-pie',
                title: 'Kissy Pie',
                desc: 'Kissy pie is delicious!',
                homepage: 'http://abc.f2e.taobao.net/specs/kissy-pie.html',
                issues: 'https://github.com/neekey/generator-kissy-pie/issues'

            },

            {
                name: 'kissy-gallery',
                title: 'Kissy Gallery',
                desc: 'Quick create an public Module for kissy gallery!',
                homepage: 'http://abc.f2e.taobao.net/specs/kissy-pie.html',
                issues: 'https://github.com/kissygalleryteam/generator-kissy-gallery/issues'
            },

            {
                name: 'tbc',
                title: '淘宝网业务组件',
                desc: 'TBC 是淘宝网常用业务组件的集合。',
                homepage: 'http://gitlab.taobao.ali.com/tbc/cheng/wikis/home',
                issues: 'http://gitlab.taobao.ali.com/tbc/cheng/issues'
            },

            {
                name: 'mm-project',
                title: '无线营销产品',
                desc: 'A generator for Yeoman. Designed for Mobile Marketing Dept with heart.',
                homepage: 'https://npmjs.org/package/generator-mm-project'
            }
        ];

        gm.list(function(err, local) {

            if (err) {
                callback(types);
                return;
            }

            var result = types.map(function(type) {

                type.installed = false;

                var found = _.find(local, function (item) {
                    return item.pkg && item.pkg.name === 'generator-' + type.name;
                });

                if (found) {
                    _.extend(type, found, {
                        installed: true
                    });
                }
                return type;
            });

            callback(result);

        });
    }
}