var system = require('./utils/system');
var fs = require('fs');
var path = require('path');
var mkdirp = require('mkdirp');

var abcRoot = system.getUserHome('.abc');
var globalJSON = path.join(abcRoot, 'global.json');

if(!fs.existsSync(abcRoot)) {
    mkdirp.sync(abcRoot);
}

if(!fs.existsSync(globalJSON)) {
    fs.writeFile(globalJSON, '{}');
}


/**
 * get global config
 * @param key
 * @returns {*}
 */
exports.get = function get(key){
    if (!key) {
        return null;
    }

    var data = this.read();

    return data[key];
};
/**
 * read from file
 * @returns {*}
 */
exports.read = function read() {
    if (!fs.existsSync(globalJSON)) {
        return {};
    }
    else {
        return JSON.parse(fs.readFileSync(globalJSON, 'utf8'));
    }
};

/**
 * set global config
 * @param key
 * @returns {*}
 */
exports.set = function set(key, value) {

    var data = this.read();

    if (!key) {
        return;
    }

    data[key] = value;

    var str = JSON.stringify(data, null, 4);

    fs.writeFileSync(globalJSON, str);
    return this;
};