var async = require('async');
var dargs = require('dargs');
var _ = require('lodash');
var spawnCommand = require('./utils/spawn-command');

module.exports = {
    /**
     * run npm command
     * @param command
     * @param paths
     * @param options
     * @param cb
     * @returns {*}
     */
    run: function (command, paths, options, spawnOptions, cb) {

        if (!cb && _.isFunction(options)) {
            cb = options;
            options = {};
        }

        options = options || {};

        spawnOptions = spawnOptions || {};

        cb = cb || function () {};

        paths = Array.isArray(paths) ? paths : (paths && paths.split(' ') || []);
        var args = [command].concat(paths).concat(dargs(options));

        return spawnCommand('npm', args, spawnOptions)
            .on('err', cb)
            .on('exit', function (err) {
                if (err === 127) {
                    console.error('Could not find npm.');
                }
                cb(err === 0 ? null : err);
            });
    }
};