var _ = require('lodash');
var events = require('events');
var util = require('util');
var processWather = require('./watch-process');
module.exports = Runner;

function Runner() {
    events.EventEmitter.apply(this);
}

util.inherits(Runner, events.EventEmitter);

Runner.prototype.watchChild = function watchChild(child) {
    processWather.watch(child, this);
};


Runner.prototype.destroy = function destroy() {

    if (this.destroyed) {
        return;
    }

    this.destroyed = true;

    if(this.child && this.child.connected) {
        this.child.kill();
    }

    this.removeAllListeners();

};