
var _ = require('lodash');

exports.watch = function (child, emitter) {
    watchStdout.call(emitter, child.stdout);
    watchStdErr.call(emitter, child.stderr);
};

/**
 *
 * @param stream {Stream}
 */
function watchStdout(stream) {
    stream.setEncoding();
    stream.on('data', function (data) {
        this.emit('stdout', data);
    }.bind(this));
}

/**
 *
 * @param stream {Stream}
 */
function watchStdErr(stream) {

    stream.setEncoding();

    var errorOutput = '';

    // debounce the output of error message
    var fn = _.debounce(function () {

        this.emit('stderr', errorOutput);
        errorOutput = '';
    }.bind(this), 200);

    stream.on('data', function (data) {
        this.emit('stdout', data);
        errorOutput += data;
        fn();
    }.bind(this));
}