
/**
 * Module dependencies.
 */

var express = require('express')
    , http = require('http')
    , path = require('path')
    , Socket = require( 'socket.io' )
    , _ = require( 'lodash' );

var app = express()
    , server = http.createServer(app)
    , io = Socket.listen(server)
    , Message = require( '../lib/socket' ).handle( io );


io.set('log level', 1);
// all environments
app.set('port', process.env.PORT || 3000);
app.set('views', __dirname + '/views');

//app.set('view engine', 'jade');
app.use(express.favicon());
app.use(express.logger('dev'));
//app.use(express.session({secret: 'taobao blue earth'}));
app.use(express.bodyParser());
app.use(express.methodOverride());
app.use(express.cookieParser());
app.use(express.static(path.join(__dirname, 'public')));

// development only
if ('development' == app.get('env')) {
  app.use(express.errorHandler());
}

// Send the client html.
function homeRoute(req, res) {
    res.sendfile(__dirname + '/angular.html')
}

app.get('/', homeRoute);
app.get('/*', homeRoute);


server.listen(app.get('port'), function(){
    console.log('Express server listening on port ' + app.get('port'));
});