APP.directive('cli', function(colorsCliFilter) {
    // return the directive link function. (compile function not needed)
    return function(scope, element, attrs) {
        // watch the expression, and update the UI on change.
        scope.$watch(attrs.cli, function(value) {
            element.html(colorsCliFilter(value));
            element.scrollTop(element.get(0).scrollHeight);
        });
    }
});

APP.directive('grunt', function () {
    return {
        restrict: 'A',
        replace: true,
        transclude: false,
        scope: {
            grunt: '=grunt'
        },
        templateUrl: 'grunt.html'
    };
});

APP.directive('yeoman', function () {
    return {
        restrict: 'A',
        replace: true,
        transclude: false,
        scope: {
            yeoman: '=yeoman',
            resolvable: '=resolvable'
        },
        templateUrl: 'yeoman-dialog.html'
    };
});



APP.directive('desk', function($compile) {
    // return the directive link function. (compile function not needed)
    return function(scope, element, attrs) {
        // watch the expression, and update the UI on change.
        scope.$watch(function () {
            return scope.$eval(attrs.desk)
        }, function(value) {
            element.html(value);
            $compile(element.contents())(scope);
        });
    }
});

APP.directive('cliDialog', function () {
    return {
        restrict: 'A',
        replace: false,
        transclude: false,
        scope: {
            dialogs: '=cliDialog'
        },
        templateUrl: 'cli-dialog.html'
    };
});