
APP.filter('colorsCli', function(){
    return function(input) {
        return cliClean(input);
    };
});


APP.filter('joinPages', function(){
    return function(pages) {
        if (!pages) {
            return '';
        }
        return pages.map(function(page){return page.name + '/' + page.version;}).join(',');
    };
});

APP.filter('formatAuthor', function() {

    function parseAuthor(author) {
        var out = '';

        if (angular.isObject(author)) {
//            out = _.template('<%= name %> <<%= email %>>', author);
            out = _.template('<%= name %>', author);
        }

        if (angular.isString(author)) {
//            out = author;
            out = author.replace(/<.+>/, '').trim();
        }

        return out;
    }

    return function(author) {
        var out = '';

        if (angular.isArray(author)) {
            out = author.map(parseAuthor).join(', ');
        } else {
            out = parseAuthor(author);
        }

        return out;
    };
});

APP.filter('join', function(){
    return function(pages, config) {
        config = config || {};

        if (!config.sep) {
            config.sep = ',';
        }
        if (!config.key) {
            config.key = 'name';
        }
        var out = '';

        if (angular.isString(pages)) {
            return pages;
        }

        if (angular.isArray(pages)) {
            out = pages.map(function(item) {
                return item[config.key];
            }).join(config.sep);
        }
        return out;
    };
});