function cliClean(str) {
    if (!str) {
        return ''
    }

    var styles = {
        //styles
        'bold'      : [1,  22, 'b'],
        'italic'    : [3,  23, 'i'],
        'underline' : [4,  24, 'span.underline'],
        'inverse'   : [7,  27, 'span.inverse'],
        //grayscale
        'white'     : [37, 39, 'span.white'],
        'grey'      : [90, 39, 'span.grey'],
        'black'     : [90, 39, 'span.black'],
        //colors
        'blue'      : [34, 39, 'span.blue'],
        'cyan'      : [36, 39, 'span.cyan'],
        'green'     : [32, 39, 'span.green'],
        'magenta'   : [35, 39, 'span.magenta'],
        'red'       : [31, 39, 'span.red'],
        'yellow'    : [33, 39, 'span.yellow']
    };

    var keys = _.keys(styles);

    _.each(keys, function(key) {
        var s = styles[key];
        var reg = '\033\\[' + s[0] + 'm(.*?)\033\\[' + s[1] + 'm';

        var match = new RegExp(reg, 'g');

        var replacer = '<<%= tag %> class="<%= cls %>">$1</<%= tag %>>';

        var tags = s[2].split('.');

        var tpl = _.template(replacer, {
            tag: tags[0],
            cls: tags[1] || ''
        });

        str = str.replace(match, tpl);
    });

    return str;
}

function testCliClean () {
    var text = '\033[1mHello\033[22m \033[1mWorld\033[22m \033[31m!\033[39m';

    var output = cliClean(text);

    var output2 = '\n';

    for(var i =0; i < output.length; i++) {
        output2 = output2 +  output[i] + ' ';
    }

    console.log(output);
//    console.log(output2);
}

