io = io.connect();

    io
    .on('connecting', function(){
        $('#connectionStatus').html('connecting...');
    })
    .on('foo', function(){
        console.log('foo')
    })
    .on('connect', init)
    .on('action:yeoman:resolvable', handleResolvable)
    .on('action:yeoman:start', function () {
        $('#cli').show();
    })
    .on('action:status:update', function (data) {
        var texts ={
            starting: '启动中',
            checking: '开始检查',
            'checking-npm': '开始检查 NPM 模块',
            'install-npm': '开始安装 NPM 模块',
            'ready': '启动完成'
        };

        $('#actionStatus').html(texts[data.status]);
    })
    .on('action:ready', function () {
            $('.action-btn').prop('disabled', false);
    })
    .on('action:yeoman:end', function () {
        //$('#cli').hide();
    })

    .on('disconnect', function() {
        $('#connectionStatus').html('closed.').css({'color': 'red'});
    })

    .on('cd', function(data) {
        $('.action-btn').prop('disabled', true);
        $('#status').html(data.current);
        $('#cli').html('');
    })

    .on('error', function(data){
        alert(data.message);
    })

    .on('action:pingback', function (data) {
        alert('pingback');
        console.log('pingback', data);
    })

    .emit('history', function(data) {
        updateHistory(data.list);
    })

function handleResolvable(data) {
    console.log('handle resolvable:', data);
    switch (data.type) {
        case 'prompt':
            var props = {};

            data.data.forEach(function(prompt){
                props[prompt.name] = window.prompt(prompt.message, prompt.default);
            });

            io.emit('action:yeoman:resolve', {
                type: 'prompt',
                props: props
            });
            break;
        case 'conflict':
            var filepath = data.data.filepath;

            var resolveObj = {
                type: 'conflict',
                filepath: filepath
            };

            resolveObj.method = window.prompt('File conflict: ' + filepath, 'overwrite');

            io.emit('action:yeoman:resolve', resolveObj);

            break;
    }
}

function updateHistory(list) {

    $('#historyList').html(
        list.map(function(item) {
            var name = item.name + ' ( ' + item.type + ' )';
            return '<li>' +
                '<a href="#' + item.root + '" class="history">' + name + '</a>' +
                '</li>'
        }).join('')
    )

}

function init () {
    $('#connectionStatus').html('connected!').css({'color': 'green'});
}

function cdApp(root) {
    console.log('switch to:', root);

    io.emit('cd', {
        root: root
    },  function(data){
        if (data.status !== 'ok') {
            alert(data.message);
            console.log(data);
        }

    });
}



var stdLog = '';

function handleStdOut(data){
    if (!data || !data.out || !data.out.length) {
        return;
    }

    stdLog = stdLog + data.out;

    $('#cli').html(stdLog);
}

io.on('action:stdout', handleStdOut);

io.on('action:stderr', handleStdOut);


$('#getInfo').click(function () {
    io.emit('info', function(data){
        alert(data.root + data.type ? ':' + data.type : '');
    });
});



$('#cd').click(function() {
    cdApp($('#rootDir').val());
});



$('body').delegate('.history', 'click', function(ev){
    ev.preventDefault();
    cdApp($(this).attr('href').replace(/^#/, ''));
});



$('#exit').click(function () {
    io.emit('exit', function (data) {
        if (data.status === 'ok') {
            alert('exited;');
        }

    });
});



$('#ping').click(function() {
    io.emit('action:ping', {
        foo: 'bar'
    });
});

$('#toggleCli').click(function(ev){
    ev.preventDefault();
    $('#cli').toggle();
});


$('#history').click(function() {
    io.emit('history', function (data) {
        console.log('\nHistory');

        data.list.forEach(function(root){
            console.log(root)
        });

        updateHistory(data.list);
    });
});

$('#runYeoman').click(function(){
    io.emit('action:yeoman:run', {
        type: 'kissy-cake'
    });
});