var gm = require('../lib/generator-manager');

describe('test generator-manager', function() {

    describe('install generator', function() {

        it('add generator by name', function (done) {
            this.timeout(60000);
            gm.install('kissy-pie', function(err) {
                console.log(err);
                done();
            });
        });
    });

    describe('list generators', function(){
        it('list all installed generator', function (done) {
            gm.list(function(err, found){
                if (err) {
                    done(err);
                    return;
                }

                found.should.be.an.instanceOf(Array);

                found.forEach(function(pkg){
                    pkg.should.have.property('root');
                    pkg.should.have.property('pkg');
                    pkg.pkg.should.have.property('name');
                    pkg.pkg.should.have.property('version');
                });

                done();
            })
        });
    });

    describe('check generator', function() {
        it('check one generator', function () {
            var result = gm.exists('kissy-pie');
            result.should.be.ok;
            result.should.have.property('name', 'generator-kissy-pie');
            result.should.have.property('version');
        });
    });

//
    describe('update generator', function() {

        it('update one generator', function (done) {
            this.timeout(600000);
            gm.update('kissy-pie', done);
        });

        it('update all generator', function(done) {
            this.timeout(600000);
            gm.update('', done);
        });
    });


});